<template>
  <!-- Radio group wrapper -->
  <div :class="getElementCssClass('wrapper')">
    <CheckBoxInput
      v-for="(option, key) in options"
      :key="key"
      v-model="vModel"
      class="flex-grow"
      :value="option"
      :name="name"
      :option-key="optionKey"
    >
      <!-- Default slot -->
      <template #default="defaultSlotProps">
        <!--
          @slot Default slot
          @binding {Object} v-bind - Dynamically bind default slot-scope from `CheckBoxInput` component
          @binding {any} option - The original option
        -->
        <slot
          name="default"
          v-bind="{
            ...defaultSlotProps,
            option: option
          }"
        />
      </template>
    </CheckBoxInput>
  </div>
</template>

<script>
// Mixins
import Variantable from '#mixins/variantable/'
import VModelable from '#mixins/v-modelable/'

export default {
  name: 'CheckBoxGroup',
  mixins: [
    VModelable,
    Variantable
  ],
  props: {
    /**
     * Radio input name
     */
    name: {
      type: String,
      required: true
    },
    /**
     * Checkbox group options
     */
    options: {
      type: Array,
      required: true
    },
    /**
     * Get option object key
     * Can be a function that takes option item as unique parameter (function (option): any) and returns the value
     * Default: "id"
     */
    optionKey: {
      type: [ String, Function ],
      default: 'id'
    },
    /**
     * OVERRIDE VModelable auto-injected prop "value"
     * => Set default value to Array
     */
    value: {
      type: [ Object, Array ],
      default () {
        return []
      }
    }
  },
  watch: {
    /**
     * Watch on options to auto-sync vModel values with existing options
     */
    options: {
      handler: function (to, from) {
        // Get only key values of this.options
        const keyValuesOnly = to.map((option) => this.getOptionKeyValue(option))
        // Check if key exists in this.vModel
        this.vModel = this.vModel.filter((option) => keyValuesOnly.includes(this.getOptionKeyValue(option)))
      }
    }
  },
  methods: {
    /**
     * Get option key based on own prop "option-key"
     * @param {object} option - The option object
     */
    getOptionKeyValue (option) {
      return typeof this.optionKey === 'function'
        ? this.optionKey(option)
        : option[this.optionKey]
    }
  },
  // Variantable options
  style: {
    fixedClasses: {
      wrapper: {}
    },
    classes: {
      wrapper: {}
    },
    variants: {
      haiti: {
        wrapper: {}
      }
    }
  }
}
</script>
